package it.eng.spago.cms.exec.operations;

import it.eng.spago.base.SourceBean;
import it.eng.spago.cms.exceptions.BuildOperationException;
import it.eng.spago.cms.util.constants.ModuleConstants;
import it.eng.spago.cms.util.constants.OperationsConstants;
import it.eng.spago.tracing.TracerSingleton;

/*
    <OPERATION name="RESTORE_OBJECT">
  	    <RESTOREOPERATION path="?" version="?" />  
  	</OPERATION>
*/

public class RestoreOperation implements Operation {

	private SourceBean operationDescriptor = null;
	
	public RestoreOperation() throws BuildOperationException {
		try {
			operationDescriptor = new SourceBean(OperationsConstants.NAME_RESTORE_OPERATION);
			operationDescriptor.setAttribute(OperationsConstants.PATH, "");
			operationDescriptor.setAttribute(OperationsConstants.VERSION, "");
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "RestoreOperation::<init>(): Error during the creation of the restore operation" +
                                "SourceBean");
			throw new BuildOperationException("RestoreOperation::<init>(): Error during the creation of the " +
					                          "restore operation SourceBean", e);
		}
	}
	
	public RestoreOperation(SourceBean descriptor){	
		operationDescriptor = descriptor;
	}
	
	public SourceBean getOperationDescriptor() {
		return operationDescriptor;
	}

	public boolean isComplete() {
		return true;
	}

	public void setPath(String path) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.PATH, path);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "RestoreOperation::setPath: Error during the path setting");
            throw new BuildOperationException("RestoreOperation::setPath: Error during the path setting", e);
		}
	}
	
	public void setVersion(String ver) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.VERSION, ver);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "RestoreOperation::setVersion: Error during the vversion setting");
            throw new BuildOperationException("RestoreOperation::setVersion: Error during the version setting", e);
		}
	}
	
	
}
