package it.eng.spago.cms.util;

import java.util.Collection;

import it.eng.spago.security.IEngUserProfile;


/**
 * 
 * Implements some utils methods to perform various operations and controls.
 * 
 */

public class ApplicationUtils {

	/**
	 * Retrive the string value array of all user functionalities. 
	 *  
	 * @param profile, the IEngUserProfile relative to the connected user
	 * @return String[], set of string values of the user functionalities.
	 */
	public static String[] getStringFunctionalities(IEngUserProfile profile) {
	
		try {
			Collection functionalities = profile.getFunctionalities();
			Object[] functsObj = functionalities.toArray();
			int size = functsObj.length;
			String[] functs = new String[size];
			for(int i=0; i<size; i++) {
				functs[i] = functsObj[i].toString();
			}
			return functs;
		} 
		catch(Exception e) {
			return new String[0];
		}
	}
	
}
